/*
	File:		MiscTests.h

	Contains:	Declaration of miscellaneous classes

	Copyright:	 1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __MISCTEST__
#define __MISCTEST__

#ifndef __LIBRARYMANAGER__
#include <LibraryManager.h>
#endif

/*******************************************************************************
** CLASS TNoVTable
********************************************************************************/

#define kTNoVTableID	"appl:test$TNoVTable,1.1"

class TNoVTable
{
	public:
				TNoVTable(long value);
				~TNoVTable();
				
	long		Add(long);
	long		Sub(long);
	
	private:
		long	fValue;
};

/*******************************************************************************
** CLASS TStdVTable
********************************************************************************/

#define kTStdVTableID	"appl:test$TStdVTable,1.1"

class TStdVTable : public TStdDynamic
{
	public:
						TStdVTable(long value);
		virtual			~TStdVTable();
		
		virtual long	Add(long);
		virtual long	Sub(long);
		
	private:
		long	fValue;
};

/*******************************************************************************
** CLASS TTimings
********************************************************************************/

#define kTTimingsID	"appl:test$TTimings,1.1"

class TTimings : public TSimpleDynamic
{
	public:
					TTimings();
					~TTimings();
				
	virtual void	VirtualFunc();
			void	Method();
	
	static  void	StaticFunc(void*);
};

#endif