/*
	File:		SITestClasses.h

	Contains:	Declarations to test the LibraryBuilder app for SI-type classes

	Copyright:	 1992-1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __LIBRARYMANAGERCLASSES__
#include <LibraryManagerClasses.h>
#endif

extern void InitTestLibrary();
extern unsigned short GetStateValue();

/*******************************************************************************
** Class TNVTest1
********************************************************************************/

#define kTNVTest1ID "quin:test$NVTest1,1.1"

class TNVTest1
{
	public:
						TNVTest1();
						~TNVTest1();
		
				int		NVTest1(int, int);
				int		NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TNVTest2
********************************************************************************/

#define kTNVTest2ID "quin:test$NVTest2,1.1"

class TNVTest2 : public TNVTest1
{
	public:
						TNVTest2();
						~TNVTest2();
		
				int		NVTest3(int, int);
				int		NVTest4(int, int);
				
	private:
		int		fField2;
};

/*******************************************************************************
** Class TSITest1
********************************************************************************/

#define kTSITest1ID "quin:test$SITest1,1.1"

#ifdef __SC__
class TSITest1 : public TSCDynamic
#else
class TSITest1 : public TDynamic
#endif
{
	public:
						TSITest1();
		virtual			~TSITest1();
		
		virtual int		VTest1(int, int);
		virtual int		VTest2(int, int);
			
				int		NVTest1(int, int);
				int		NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest2
********************************************************************************/

#define kTSITest2ID "quin:test$SITest2,1.1"

#ifdef __SC__
class TSITest2
#else
class TSITest2 : public SingleObject
#endif
{
	public:
						TSITest2();
		virtual			~TSITest2();
		
		virtual int		VTest1(int, int);
		virtual int		VTest2(int, int);
			
				int		NVTest1(int, int);
				int		NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest3
**
** The Symantec C++ version does not have _machdl on it, because if you 
** #include <GlobalNew.h> - the compiler uses the overridden version - which
** does not give you a handle.  The results are ugly!
********************************************************************************/

#define kTSITest3ID "quin:test$SITest3,1.1"

#ifdef __SC__
class TSITest3
#else
class TSITest3 : public HandleObject
#endif
{
	public:
						TSITest3();
		virtual			~TSITest3();
		
		virtual int		VTest1(int, int);
		virtual int		VTest2(int, int);
			
				int		NVTest1(int, int);
				int		NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest4
********************************************************************************/

#define kTSITest4ID "quin:test$SITest4,1.1"

class TSITest4
{
	public:
						TSITest4();
		virtual			~TSITest4();
		
		virtual int		VTest1(int, int);
		virtual int		VTest2(int, int);
		virtual int		VTest3(int, int);
		virtual int		VTest4(int, int);
			
				int		NVTest1(int, int);
				int		NVTest2(int, int);
				
	private:
		int		fField;
};

/*******************************************************************************
** Class TSITest5
********************************************************************************/

#define kTSITest5ID "quin:test$SITest5,1.1"

class TSITest5 : public TSITest4
{
	public:
						TSITest5();
		virtual			~TSITest5();
		
		virtual int		VTest1(int, int);
		virtual int		VTest2(int, int);
		virtual int		VTest4(int, int);
			
				int		NVTest1(int, int);
				int		NVTest2(int, int);
				
	private:
		int		fField2;
};

