/*
	File:		TestTimeScheduler.h

	Contains:	Declaration for TTestTimeScheduler class

	Copyright:	 1991-1993 by Apple Computer, Inc., all rights reserved.

*/

#ifndef __TESTTIMESCHEDULER__
#define __TESTTIMESCHEDULER__

#ifndef __TESTCLASS__
#include "TestClass.h"
#endif
#ifndef __LIBRARYMANAGERCLASSES__
#include <LibraryManagerClasses.h>
#endif

#define kTTestTimeSchedulerID	kTestToolPrefix "TTestTimeScheduler,1.1"

class TTestTimeScheduler : public TTestTool
{
	BodyTest(TimeScheduler, TimeScheduler);
	
	public:
		virtual void		RunStressTest(Boolean);	
		
		size_t	fNumOperations;
		size_t	fResolution;
		size_t	fIterations;
		size_t	fMinSchedule;
		size_t	fMaxSchedule;
		Boolean	fStress;
};

/**********************************************************************
** Support class
***********************************************************************/

class TTimeOperation : public TOperation
{
	public:
						TTimeOperation(TTimeScheduler*, int which);
		virtual			~TTimeOperation();
		
		virtual void	Process();
		
	TTimeScheduler*	fSched;
	TStopwatch*		fWatch;
	int				fDifference;
	size_t			fWhen;
	int				fWhich;
	short			fTest;
	Boolean			fFired;
};



#endif


